﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinTree
Imports System.Drawing

Namespace WT_ScrollBarToTheLeft
	Friend Class CustomCreationFilter
		Implements IUIElementCreationFilter

		Public Sub AfterCreateChildElements(ByVal parent As UIElement) Implements IUIElementCreationFilter.AfterCreateChildElements
			Dim treeUIElement = TryCast(parent, UltraTreeUIElement)

			If treeUIElement Is Nothing Then
				Return
			End If

			Dim verticalScrollbarUIElement = parent.GetDescendant(GetType(VerticalScrollbarUIElement))
			Dim nodeAreaUIElement = parent.GetDescendant(GetType(NodeClientAreaUIElement))

			If nodeAreaUIElement Is Nothing OrElse verticalScrollbarUIElement Is Nothing Then
				Return
			End If

			Dim verticalScrollbarRectangle = verticalScrollbarUIElement.Rect
			Dim nodeAreaRectangle = nodeAreaUIElement.Rect

			verticalScrollbarUIElement.Rect = New Rectangle(nodeAreaRectangle.Location, verticalScrollbarRectangle.Size)
			nodeAreaUIElement.Rect = New Rectangle(nodeAreaRectangle.X + verticalScrollbarRectangle.Width, nodeAreaRectangle.Y, nodeAreaRectangle.Width, nodeAreaRectangle.Height)
		End Sub

		Public Function BeforeCreateChildElements(ByVal parent As UIElement) As Boolean Implements IUIElementCreationFilter.BeforeCreateChildElements
			Return False
		End Function
	End Class
End Namespace